// ########################################################################
// ## isotest.cc:                                                        ##
// ## Isomorphietest fr trivalente Graphen                              ##
// ## Copyright Thomas Dreibholz, uzs6pq@ibm.rhrz.uni-bonn.de            ##
// ##           WWW Homepage:     http://ibm.rhrz.uni-bonn.de/~uzs6pq    ##
// ########################################################################

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <bool.h>

#include "trigraph.h"
#include "trigraph.icc"


// Variablen zur Permutation 
int* perm;
int  id;


// Vergleiche Graph t1 mit Permutation von t2
// => true, falls Graphen gleich
// => false, falls Graphen verschieden
bool VergleichePermutation(const int N, const TriGraph& t1, const TriGraph& t2)
{
   for(int i = 0;i < N;i++) {
      for(int j = i + 1;j < N;j++) {
         if(t1.Verbunden(i,j) != t2.Verbunden(perm[i + 1],perm[j + 1])) {
            return(false);
         }
      } 
   }  
   return(true);
}


// Erzeuge alle Permutationen von {1,...,N}
bool TesteAllePermutationen(const TriGraph& t1, const TriGraph& t2,
                            const int N, int k)
{
   perm[k] = id;
   id++;
   if(id == N) {
      if(VergleichePermutation(N,t1,t2) == true) {
         return(true);
      }
   }  
   for(int i = 1;i <= N;i++) {
      if(perm[i] == -1) {
         if(TesteAllePermutationen(t1,t2,N,i) == true) {
            return(true);
         }
      }
   }
   id--;
   perm[k] = -1;  
   return(false);
}


// Der Isomorphietest fr trivalente Graphen
bool IsomorphieTest(const TriGraph& t1, const TriGraph& t2)
{
   const int N = t1.Knoten();
   perm = new int[N + 1];
   for(int i = 0;i <= N;i++) {
      perm[i] = -1;
   } 
   id = -1;

   bool ergebnis = TesteAllePermutationen(t1,t2,N,0);

   delete perm;
   return(ergebnis);
}
